Imports System.Windows.Forms
Imports System.Drawing

Public Class Listview
    Implements IDisposable 'Inherit from IDisposable if you need Basic4ppc to free resources when the application is closed.

    Private WithEvents ListView1 As System.Windows.Forms.ListView 'The "real" object.
    Public Event ValueChanged As EventHandler 'The event handler name must match the event name.
    Private eventObject() As Object 'One object[] for each event (one event here).

    Sub New(ByVal FormName As Control, ByVal Left As Int32, ByVal Top As Int32, ByVal Width As Int32, ByVal Height As Int32)
        'dz Begin *****************
        ListView1 = New System.Windows.Forms.ListView
        'dz End *****************

        ListView1.Left = Left
        ListView1.Top = Top
        ListView1.Width = Width
        ListView1.Height = Height
        FormName.Controls.Add(ListView1)

        ' Select the item and subitems when selection is made
        ListView1.FullRowSelect = True

    End Sub

    'dz Begin *****************
    Public WriteOnly Property View() As Int32
        Set(ByVal Value As Int32)
            ListView1.View = Value
        End Set
    End Property
    'dz End *****************

    Public Sub ColumnsAdd(ByVal Text As String, Optional ByVal TextAlignment As Int32 = 0)

        If TextAlignment = 0 Then
            ListView1.Columns.Add(Text, -2, HorizontalAlignment.Left)
        ElseIf TextAlignment = 1 Then
            ListView1.Columns.Add(Text, -2, HorizontalAlignment.Right)
        ElseIf TextAlignment = 2 Then
            ListView1.Columns.Add(Text, -2, HorizontalAlignment.Center)
        End If
    End Sub

    Public Sub item(ByVal ParamArray Celle() As String)
        Dim i As Integer = 0
        Dim n As Integer = 0

        i = UBound(Celle)

        If i > 0 Then
            With ListView1.Items.Add(New ListViewItem(Celle(0)))
                For n = 1 To ListView1.Columns.Count - 1
                    If n < i Then
                        .SubItems.Add(Celle(n))
                    End If
                Next n
            End With
        End If
    End Sub

    'dz Begin *****************
    Public Sub AddItem(ByVal ParamArray Celle() As String)
        Dim i As Integer = 0
        Dim n As Integer = 0
        Dim lvi As ListViewItem


        i = UBound(Celle)

        If i > 0 Then

            lvi = New ListViewItem(Celle(0))

            For n = 1 To ListView1.Columns.Count
                If n <= i Then
                    lvi.SubItems.Add(Celle(n))
                End If
            Next

            ListView1.Items.Add(lvi)

        End If
    End Sub
    'dz End *****************
    Public Sub Clear()
        ListView1.Clear()
    End Sub

    Public Sub Show()
        ListView1.Show()
    End Sub

    Public Sub Visible(ByVal modus As Boolean)
        ListView1.Visible = modus
    End Sub

    Public Property Left() As Int32
        Get
            Return ListView1.Left
        End Get
        Set(ByVal Value As Int32)
            ListView1.Left = Value
        End Set
    End Property

    Public Property Top() As Int32
        Get
            Return ListView1.Top
        End Get
        Set(ByVal Value As Int32)
            ListView1.Top = Value
        End Set
    End Property

    Public Property Width() As Int32
        Get
            Return ListView1.Width
        End Get
        Set(ByVal Value As Int32)
            ListView1.Width = Value
        End Set
    End Property

    Public Property Height() As Int32
        Get
            Return ListView1.Height
        End Get
        Set(ByVal Value As Int32)
            ListView1.Height = Value
        End Set
    End Property

    Public ReadOnly Property DLLVersion() As Double
        Get
            Return 1.0
        End Get
    End Property

    Public Sub Dispose() Implements System.IDisposable.Dispose
        If Not ListView1 Is Nothing Then
            ListView1.Dispose()
        End If
    End Sub
End Class
